#include <u.h>
#include <libc.h>
#include <auth.h>
#include <fcall.h>
#include <thread.h>
#include <9p.h>
#include <json.h>
#include "axosoft.h"

int
auth(Sess *s, char *url)
{
	int rc;
	char *p;
	Jvalue *v;
	UserPasswd *up;

	rc = -1;
	if((up = auth_getuserpasswd(auth_getkey, "url=%s proto=pass service=axosoft", url)) == nil)
		sysfatal("cannot get key - %r");
/*
https://someaccount.axosoft.com/auth?response_type=code
                                      &client_id=00000000-0000-0000-0000-000000000000
                                      &redirect_uri=https://myaxosoftapp.com/receive_authorization_code
                                      &scope=read%20write
                                      &expiring=false
*/
	if((v = exch(s, nil, "api/oauth2/token?"
			"grant_type=password&"
			"username=%s&"
			"password=%s&"
			"client_id=00000000-0000-0000-0000-000000000000&"
			"client_secret=xyzzy&"
			"scope=read%20write",
			up->user, up->passwd)) == nil){
		warn("cannot get build info, %r\n");
		return -1;
	}
	if((p = json_strval(v, "access_token")) != nil){
		s->accesstoken = estrdup9p(p);
		fprint(2, "%s: autherisation ok\n", argv0);
		rc = 0;
	}

	if((p = json_strval(v, "error_description")) != nil){
		fprint(2, "%s: autherisation failed, %s\n", argv0, p);
	}

	json_free(v);
	return rc;
}

